<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode Proyek</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Kode Proyek"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Status</label>

            <b-form-select
              v-model="filter.status"
              :options="options.statuses"
              size="lg"
            ></b-form-select>
          </div>
        </div>

        <div class="d-flex justify-content-end">
          <button class="btn btn-primary btn-md">
            <i class="flaticon2-search-1"></i> Filter
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="table-responsive">
          <table
            class="table table-head-custom table-vertical-center table-head-bg table-borderless"
          >
            <thead>
              <tr class="text-left">
                <th style="min-width: 250px" class="pl-7">
                  <span class="text-dark-75">Kode Proyek</span>
                </th>
                <th style="min-width: 100px">Nama Proyek</th>
                <th style="min-width: 100px">Status</th>
                <th style="min-width: 100px">Owner</th>
                <th style="min-width: 101px">Aksi</th>
              </tr>
            </thead>

            <tbody>
              <template
                v-for="(item, i) in this.$store.getters.getterListChecklist"
              >
                <tr v-bind:key="i">
                  <td class="pl-0 ">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.code }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.name }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.status }}
                    </span>
                  </td>

                  <td>
                    <span class="text-muted font-weight-bold d-block">
                      {{ item.owner }}
                    </span>
                  </td>

                  <td class="pr-0">
                    <button
                      class="btn btn-light-success font-weight-bolder font-size-sm"
                      @click.prevent="editDistribution"
                    >
                      <i class="flaticon-edit"></i>
                    </button>
                  </td>
                </tr>
              </template>
            </tbody>
          </table>
        </div>
      </div>

      <!-- pagination -->
      <div
        v-bind:class="{
          'd-none': paginationChecklist
        }"
      >
        <div class="d-flex justify-content-end">
          <button
            class="btn btn-primary"
            v-if="this.$store.getters.getterStartChecklist == 0"
            disabled
          >
            {{ prevChecklist }}
          </button>
          <button
            class="btn btn-primary"
            v-else
            @click.prevent="prevPageChecklist"
          >
            {{ prevChecklist }}
          </button>

          <button
            class="btn btn-primary"
            v-if="
              this.$store.getters.getterActiveChecklist ===
                this.$store.getters.getterTotalChecklist
            "
            disabled
          >
            {{ nextChecklist }}
          </button>
          <button
            class="btn btn-primary"
            v-else
            @click.prevent="nextPageChecklist"
          >
            <div
              class="text-center"
              v-bind:class="{
                'd-none': loaderNextChecklist
              }"
            >
              <b-spinner
                variant="secondary"
                label="Spinning"
                style="width: 1rem; height: 1rem;"
              ></b-spinner>
            </div>
            {{ nextChecklist }}
          </button>
        </div>
      </div>
      <!-- end pagination -->
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { GET_CHECKLIST_DISTRIBUTION } from "@/core/services/store/distribution.module";

export default {
  name: "check-list",
  data() {
    return {
      filter: {
        status: null,
        name: null,
        code: null,
        owner: null,
        contractNumber: null
      },
      options: {
        statuses: [
          { value: null, text: "Pilih Status" },
          { value: "open", text: "Open" },
          { value: "close", text: "Close" }
        ]
      },
      prevChecklist: "prev",
      nextChecklist: "Next",
      paginationChecklist: true,
      loaderNextChecklist: true
    };
  },
  methods: {
    async nextPageChecklist() {
      var start = 1;
      var end = 2;
      var active = 2;
      await this.$store.dispatch(GET_CHECKLIST_DISTRIBUTION, {
        start: start,
        end: end,
        activePage: active
      });
    },

    async prevPageChecklist() {
      var start = 0;
      var end = 1;
      var active = 1;
      await this.$store.dispatch(GET_CHECKLIST_DISTRIBUTION, {
        start: start,
        end: end,
        activePage: active
      });
    },

    editDistribution() {
      this.$router.push("/project/distribution/check");
    }
  },
  async mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Checklist Distribution" }]);

    this.loaderNextChecklist = false;
    this.nextChecklist = "";
    await this.$store.dispatch(GET_CHECKLIST_DISTRIBUTION, {
      start: 0,
      end: 1,
      activePage: 1
    });
    this.loaderNextChecklist = true;
    this.nextChecklist = "Next";
    if (this.$store.getters.getterTotalChecklist >= 2) {
      this.paginationChecklist = false;
    }
  }
};
</script>

<style></style>
